unit ChatFactory;

interface

uses
  Classes, SysUtils, TextServerFactroy, UserInfo, TextServerInterface;

type
  TChatFactory = class(TTextServerFactroy)
  private
  public
    function GetUserInfo(AConnection:TObject):TUserInfo; override;
    function GetTextServerInterface:TTextServerInterface; override;
  end;

implementation

uses
  TextServerDefault, ChatUserInfo;

{ TChatFactory }

function TChatFactory.GetTextServerInterface: TTextServerInterface;
begin
  if Owner <> nil then  
    Result := TTextServerDefault.Create(Owner.Owner)
  else
    Result := TTextServerDefault.Create(Owner);
end;

function TChatFactory.GetUserInfo(AConnection: TObject): TUserInfo;
begin
  Result := TChatUserInfo.Create(AConnection);
end;

end.
