unit _fmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdThreadMgr, IdThreadMgrDefault, IdBaseComponent, IdComponent,
  IdTCPServer, StdCtrls;

type
  TfmMain = class(TForm)
    IdTCPServer: TIdTCPServer;
    IdThreadMgrDefault: TIdThreadMgrDefault;
    moMsg: TMemo;
    procedure IdTCPServerExecute(AThread: TIdPeerThread);
    procedure IdTCPServerConnect(AThread: TIdPeerThread);
  private
    procedure do_SendToAll(Text:string);
  public
  end;

var
  fmMain: TfmMain;

implementation

{$R *.dfm}

procedure TfmMain.do_SendToAll(Text: string);
var
  List : TList;
  Loop : Integer;
  Thread : TIdPeerThread;
begin
  List:= IdTCPServer.Threads.LockList;
  try
    for Loop := 0 to List.Count-1 do begin
      Thread:= Pointer(List.Items[Loop]);
      Thread.Connection.Write(Text+#10);
    end;
  finally
    IdTCPServer.Threads.UnlockList;
  end;
end;

procedure TfmMain.IdTCPServerConnect(AThread: TIdPeerThread);
begin
  AThread.Connection.Write('Connected!!'+#10#10);
end;

procedure TfmMain.IdTCPServerExecute(AThread: TIdPeerThread);
var
  sText : string;
begin
  sText:= AThread.Connection.ReadLn(#10);
  if sText = 'Ping' then begin
    Exit;
  end;
  
  do_SendToAll(sText);

  moMsg.Lines.Add(sText);
  moMsg.Lines.Add('**********************************************************');
end;

end.
