package Lib
{
	import flash.errors.*;
	import flash.events.*;
	import flash.net.Socket;
	import flash.utils.Timer;

	public class TClientSocket extends Socket
	{
   	 	public var OnConnected : Function = null;
  	 	public var OnDisconnected : Function = null;
   	 	public var OnError : Function = null;
   	 	public var OnReceive : Function = null;
   	 	public var OnReceiveText : Function = null;
   	 	public var OnSecurityError : Function = null;
   	 	
		public function TClientSocket(host:String=null, port:int=0.0) {
       		super(host, port);
       		
        	do_ConfigureListeners();

       		FTimer.addEventListener("timer", on_Timer);
		}
		
    	public function WriteLn(Text:String):void {
        	Text += String.fromCharCode(7);
        	try {
          	  	writeUTFBytes(Text);
          	  	flush();
        	} catch(e:IOError) {
//            	trace(e);
        	}
    	}

		private var FBuffer : String = "";
		private var FTimer : Timer = new Timer(300, 0);
		
   	   	private function on_Timer(event:TimerEvent):void {
   	   		// 서버에게 나에게 온 메시지를 전송하라고 알린다.
   	   		if (this.connected) WriteLn("");
       	}		    
       	
    	private function do_ConfigureListeners():void {
     	   	addEventListener(Event.CONNECT, do_Connected);
        	addEventListener(Event.CLOSE, do_Disconnected);
      	 	addEventListener(IOErrorEvent.IO_ERROR, do_Error);
       	 	addEventListener(ProgressEvent.SOCKET_DATA, do_Receive);
        	addEventListener(SecurityErrorEvent.SECURITY_ERROR, do_SecurityError);
    	}

    	private function do_Connected(event:Event):void {
   	 		if (OnConnected != null) OnConnected(this);
       		FTimer.start();
    	}

    	private function do_Disconnected(event:Event):void {
       		FTimer.stop();
   	 		if (OnDisconnected != null) OnDisconnected(this);
    	}

    	private function do_Error(event:IOErrorEvent):void {
   	 		if (OnError != null) OnError(this);
//        	trace("do_Error: " + event);
    	}

    	private function do_Receive(event:ProgressEvent):void {
    		FBuffer += readUTFBytes(bytesAvailable);
   	 		if (OnReceive != null) {
   	 			OnReceive(this, FBuffer);
   	 			FBuffer = "";
   	 		} else if (OnReceiveText != null) {
   	 			var iIndex : int = FBuffer.indexOf(String.fromCharCode(7));
   	 			while (iIndex != -1) {
   	 				OnReceiveText(this, FBuffer.substr(0, iIndex));
   	 				FBuffer = FBuffer.substr(iIndex+1);  
   	 				iIndex = FBuffer.indexOf(String.fromCharCode(7));	 			
   	 			}
   	 		}
    	}
    	
	    private function do_SecurityError(event:SecurityErrorEvent):void {
   	 		if (OnSecurityError != null) OnSecurityError(this);
//    	    trace("securityErrorHandler: " + event);    	    
   	 	}
    }
}
