unit _fmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdThreadMgr, IdThreadMgrDefault, IdBaseComponent, IdComponent,
  IdTCPServer, StdCtrls;

type
  TfmMain = class(TForm)
    IdTCPServer: TIdTCPServer;
    IdThreadMgrDefault: TIdThreadMgrDefault;
    moMsg: TMemo;
    procedure IdTCPServerExecute(AThread: TIdPeerThread);
    procedure IdTCPServerConnect(AThread: TIdPeerThread);
    procedure IdTCPServerDisconnect(AThread: TIdPeerThread);
  private
    procedure do_SendToAll(Text:string);
  public
  end;

var
  fmMain: TfmMain;

implementation

{$R *.dfm}

procedure TfmMain.do_SendToAll(Text: string);
var
  List : TList;
  Loop : Integer;
  Buffer : TStringList;
  Thread : TIdPeerThread;
begin
  List:= IdTCPServer.Threads.LockList;
  try
    for Loop := 0 to List.Count-1 do begin
      Thread:= Pointer(List.Items[Loop]);
      Buffer:= pointer(Thread.Data);
      if Buffer = nil then Continue;

      Buffer.Add(Text + #7);
    end;
  finally
    IdTCPServer.Threads.UnlockList;
  end;
end;

procedure TfmMain.IdTCPServerConnect(AThread: TIdPeerThread);
var
  Buffer : TStringList;
begin
  Buffer:= TStringList.Create;
  AThread.Data:= Buffer;
  Buffer.Add('Msg=Connected!!' + #7);
end;

procedure TfmMain.IdTCPServerDisconnect(AThread: TIdPeerThread);
var
  Buffer : TStringList;
begin
  Buffer:= pointer(AThread.Data);
  AThread.Data:= nil;

  Buffer.Free;
end;

procedure TfmMain.IdTCPServerExecute(AThread: TIdPeerThread);
var
  sText : string;
  Buffer : TStringList;
begin
  Buffer:= pointer(AThread.Data);
  if Buffer = nil then Exit;
  
  sText:= AThread.Connection.ReadLn(#7);

  if sText = 'Ping' then begin
    if Buffer.Count > 0 then begin
      AThread.Connection.Write(Buffer.Text);
      Buffer.Clear;
    end;
    Exit;
  end;

  do_SendToAll(sText);
  
  moMsg.Lines.Add(sText);
  moMsg.Lines.Add('**********************************************************');
end;

end.
