unit _fmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, EasyServerSocket, StdCtrls, EasySocketInfo;

type
  TfmMain = class(TForm)
    moMsg: TMemo;
    ServerSocket: TEasyServerSocket;
    procedure ServerSocketClientConnected(Sender: TObject;
      ASocket: TCustomWinSocket; SocketInfo: TEasySocketInfo);
    procedure ServerSocketReceivePacket(Sender: TObject;
      ASocket: TCustomWinSocket; SocketInfo: TEasySocketInfo; Text: string);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  public
  end;

var
  fmMain: TfmMain;

implementation

{$R *.dfm}

procedure TfmMain.FormCreate(Sender: TObject);
begin
  ServerSocket.Open;
end;

procedure TfmMain.FormDestroy(Sender: TObject);
begin
  ServerSocket.Close;
end;

procedure TfmMain.ServerSocketClientConnected(Sender: TObject;
  ASocket: TCustomWinSocket; SocketInfo: TEasySocketInfo);
begin
  SocketInfo.Logined := true;
  
  // Flex Croess Domain  ذ 
  ServerSocket.SendTo(ASocket,
    '<cross-domain-policy>' +
    '  <allow-access-from domain="*" to-ports="*" />' +
    '</cross-domain-policy>' + #7 + #0 + #10
  );
end;

procedure TfmMain.ServerSocketReceivePacket(Sender: TObject;
  ASocket: TCustomWinSocket; SocketInfo: TEasySocketInfo; Text: string);
var
  Loop : integer;
  Packet : TStringList;
  Proc : procedure (ASocket:TCustomWinSocket; SocketInfo:TEasySocketInfo; Packet:TStringList) of object;
begin
  if Text = '' then Exit;

  Packet := TStringList.Create;
  try
    Text := StringReplace(Text, #10, #13#10, [rfReplaceAll]);
    Packet.Text := Text;

    moMsg.Lines.Add(Text);
    moMsg.Lines.Add('');

    if Packet.Values['SendTo'] = 'All' then
      ServerSocket.SendToAll(Packet.Text);
    if Packet.Values['SendTo'] = 'Other' then
      ServerSocket.SendToOther(ASocket, Packet.Text);
    if Packet.Values['SendTo'] = 'UserID' then
      ServerSocket.SendToUserID(Packet.Values['SendTo.UserID'], Packet.Text);

    TMethod(Proc).Data := Sender;
    TMethod(Proc).Code := MethodAddress('rp_' + Packet.Values['Code']);
    if Assigned(Proc) then Proc(ASocket, SocketInfo, Packet);
  finally
    Packet.Free;
  end;
end;

end.
