unit _fmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, StdCtrls, ExtCtrls;

type
  TfmMain = class(TForm)
    ServerSocket: TServerSocket;
    moMsg: TMemo;
    procedure ServerSocketClientRead(Sender: TObject; Socket: TCustomWinSocket);
  private
    function do_CheckPolicy(Socket:TCustomWinSocket; Text:string):boolean;
  public
  end;

var
  fmMain: TfmMain;

implementation

{$R *.dfm}

function TfmMain.do_CheckPolicy(Socket: TCustomWinSocket; Text: string):boolean;
begin
  Result := Pos('<policy-file-request/>', Text) > 0;
  if Result  then begin
    Socket.SendText(
      '<cross-domain-policy>' +
      '  <allow-access-from domain="*" to-ports="*" />' +
      '</cross-domain-policy>' + #0
    );
    Exit;
  end;
end;

procedure TfmMain.ServerSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  sText : string;
  Loop : Integer;
begin
  sText:= Socket.ReceiveText;
//  moMsg.Lines.Add(sText);

  if do_CheckPolicy(Socket, sText) = true then Exit;

  if sText = 'Ping'+#7 then begin
    Exit;
  end;

  for Loop := 0 to ServerSocket.Socket.ActiveConnections - 1 do
    ServerSocket.Socket.Connections[Loop].SendText(sText);
end;

end.
